without warning

global constant
	NL = {13,10},		-- CR, LF
	MMX_REG = 1,
	XMM_REG = 2,
	powersof2 = {#100,#200,#400,#800,#1000,#2000,#4000,#8000,#10000,
	             #20000,#40000,#80000,#100000,#200000,#400000,#800000,
	             #1000000,#2000000,#4000000,#5000000,#6000000,#8000000}

global constant COND = -2,
         NUMRANGE = -3,
         LESSBITSSET = -4
         
global integer
	ifs,
	cases,
	loops,
	calls,
	outfile,
	usesConsole,
	usesCR, usesLF,
	usesLoops,
	usesFP,
	usesIP,
	usesDict,
	usesMiscS,
	usesCase,
	usesPrint,
	strops,
	noMangle,
	p1,p2,
	dllentry,
	fastfloat

global sequence
	code,
	maincode,
	deferred,
	ifStack,
	literals,
	includes,
	labelPrefix,
	CMD,
	pendingWordDef,
	userWords,
	variables,
	regs,
	rstack,
	fastCmp

global integer
	linesRemoved,
	constRemoved,
	optLevel

global sequence
	patvars,
	constlist
	

global sequence cfgin,morefiles
global sequence outname,entry,fentry,nofpu
global integer cfgfile,dll,infpos
global atom t1




global function cut_filename(sequence fname)
	integer p
	
	p = length(fname)
	while p>=1 do
		if fname[p] = '.' then
			exit
		end if
		p -= 1
	end while

	if p then
		return {fname[1..p-1],fname[p+1..length(fname)]}
	end if
	
	return fname
end function



-- Insert sequence 'what' in sequence 'dest' of lexically ordered sequences
global function ordered_insert(sequence what,sequence dest)
	integer lb,ub,middle,res

	if not length(dest) then
		return {what}
	end if
	
	lb = 0
	ub = length(dest)-1
	
	while 1 do
		if ub<lb then
			return dest
		end if

		middle = floor((lb+ub)/2)
		
		res = compare(what,dest[middle+1])
		if res=0 then
			return dest
		elsif res<0 then
			if middle=0 then
				exit
			elsif compare(what,dest[middle])>0 then
				exit
			end if
			ub = middle-1
		else
			if middle=length(dest)-1 then
				if middle=0 then
					middle=1
				else
					middle += 1
				end if
				exit
			elsif compare(what,dest[middle+2])<0 then
				middle += 1
				exit
			end if
			lb = middle+1
		end if
	end while
	
	middle += 1
	if middle=1 then
		dest = {what}&dest
	elsif middle>length(dest) then
		dest = append(dest,what)
	else
		dest = dest[1..middle-1] & {what} & dest[middle..length(dest)]
	end if
	
	return dest
end function



		
-- Insert sequence 'what' in sequence 'dest' of lexically ordered sequences
global function assoc_insert(sequence name,object data,sequence dest)
	integer lb,ub,middle,res
	sequence names
	
	names = dest[1]
	
	if not length(names) then
		return {{name},{data}}
	end if
	
	lb = 0
	ub = length(names)-1
	
	while 1 do
		if ub<lb then
			return dest
		end if

		middle = floor((lb+ub)/2)
		
		res = compare(name,names[middle+1])
		if res=0 then
			return dest
		elsif res<0 then
			if middle=0 then
				exit
			elsif compare(name,names[middle])>0 then
				exit
			end if
			ub = middle-1
		else
			if middle=length(names)-1 then
				if middle=0 then
					middle=1
				else
					middle += 1
				end if
				exit
			elsif compare(name,names[middle+2])<0 then
				middle += 1
				exit
			end if
			lb = middle+1
		end if
	end while
	
	middle += 1
	if middle=1 then
		dest[1] = {name}&names
		dest[2] = {data}&dest[2]
	elsif middle>length(names) then
		dest[1] = append(names,name)
		dest[2] = append(dest[2],data)
	else
		dest[1] = names[1..middle-1] & {name} & names[middle..length(names)]
		dest[2] = dest[2][1..middle-1] & {data} & dest[2][middle..length(dest[2])]
	end if
	
	return dest
end function


	

global function make_label(sequence id)
	sequence s

	if noMangle then
		return id
	end if
	
	s = ""
	for i=1 to length(id) do
		s &= "%02x"
	end for
	
	return labelPrefix&"lbl_"&sprintf(s,id)
end function



global procedure ADD_CODE(sequence instr,integer section)
	if length(pendingWordDef) then
		code &= instr
	else
		maincode &= instr
	end if
end procedure


global procedure REMOVE_CODE(integer i1,integer i2)
	if length(pendingWordDef) then
		code = code[1..i1-1]&code[i2+1..length(code)]
	--else
	--	maincode &= instr
	end if
end procedure

